class TDM_Mutator expands Mutator config(MOS_HASM);

var config string 	TDMGameName,
			TDMLeftMessage,
			TDMEnteredMessage,
			RedTeamIcon,
			BlueTeamIcon,
			GreenTeamIcon,
			GoldTeamIcon,
			RedTeamName,
			BlueTeamName,
			GreenTeamName,
			GoldTeamName;

function PreBeginPlay ()
{
	Super.PreBeginPlay();
	SaveConfig();

	Level.Game.ScoreBoardType = Class'TDM_SB';
	Level.Game.HUDType = Class'TDM_HUD';
	Level.Game.GameName = TDMGameName;
	Level.Game.LeftMessage = TDMLeftMessage;
	Level.Game.EnteredMessage = TDMEnteredMessage;

	AddMutator(Level.Spawn(class'TDM_StatsMutator'));
	AddMutator(Level.Spawn(class'IP2Country'));
	SetTimer(1.0,True);
}

function Timer()
{
local Pawn P;

	Super.Timer();

	for (P = Level.PawnList; P != None; P = P.NextPawn)
		{
		if ( P.IsA('PlayerPawn') )
			{
			PRI(PlayerPawn(P).PlayerReplicationInfo).RedTeamIcon = RedTeamIcon;
			PRI(PlayerPawn(P).PlayerReplicationInfo).BlueTeamIcon = BlueTeamIcon;
			PRI(PlayerPawn(P).PlayerReplicationInfo).GreenTeamIcon = GreenTeamIcon;
			PRI(PlayerPawn(P).PlayerReplicationInfo).GoldTeamIcon = GoldTeamIcon;
			PRI(PlayerPawn(P).PlayerReplicationInfo).RedTeamName = RedTeamName;
			PRI(PlayerPawn(P).PlayerReplicationInfo).BlueTeamName = BlueTeamName;
			PRI(PlayerPawn(P).PlayerReplicationInfo).GreenTeamName = GreenTeamName;
			PRI(PlayerPawn(P).PlayerReplicationInfo).GoldTeamName = GoldTeamName;
			}
		}
}

defaultproperties
{
TDMGameName="-MOS- Team DeathMatch"
TDMLeftMessage=" is a quitter!!!"
TDMEnteredMessage=" joined the action!"
RedTeamIcon=MOS_HASM_v1.RedTeam
BlueTeamIcon=MOS_HASM_v1.BlueTeam
GreenTeamIcon=MOS_HASM_v1.GreenTeam
GoldTeamIcon=MOS_HASM_v1.GoldTeam
RedTeamName=[Red Team]
BlueTeamName=[Blue Team]
GreenTeamName=[Green Team]
GoldTeamName=[Gold Team]
}
